# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de la gestion de la entidad GrupoUsuario 
#
# Controlador encargado de la gestión de grupos de usuarios. Este controlador es utilizado desde las secciones:
# * Sección administración: se utiliza para crear grupos y asignarles usuarios.
class GrupoUsuarioController < ApplicationController

  before_filter :autorizar_admin, only: [:listado, :editar_nuevo, :modificar_crear, :eliminar]
  before_filter :autorizar_admin_o_rol_agente, except: [:listado, :editar_nuevo, :modificar_crear, :eliminar]
  
  # en administracion: se redirecciona por defecto a ordenado
  def index
    redirect_to :action => 'listado'
  end

  # en administracion: lista las agentes que hay en el sistema
  def listado
    @grupos = @paginado = GrupoUsuario.paginate( :order => "nombre", :page => params[:page], :per_page => (session[:por_pagina] or 20) )
  end

  # en administracion: prepara el formulario de edición o creación
  def editar_nuevo
    @grupo = GrupoUsuario.find_by_id(params[:id]) || GrupoUsuario.new
    render :partial => "formulario"
  end

  # en administracion: modifica o crea
  def modificar_crear
    @grupo = GrupoUsuario.find_by_id(params[:id]) || GrupoUsuario.new
    @grupo.update_attributes params[:grupo]
    msg @grupo
    redirect_to :action => "listado"
  end

  # en administracion: elimina
  def eliminar
    @grupo = GrupoUsuario.find(params[:id])
    @grupo.destroy
    msg_eliminar @grupo
    redirect_to :action => 'listado'
  end

  #++
  # Asignar GRUPOS 
  #--

  def asignar_grupo
    @objeto = eval( params[:objeto].split('_').map(&:capitalize).join ).find( params[:id].to_s )
    @listado_grupos = GrupoUsuario.find(:all, :order => "nombre").collect{ |u| [u.nombre, u.id] } - @objeto.grupo_usuario.collect{ |u| [u.nombre, u.id] }
    @grupo_actual = GrupoUsuario.find( params[:grupo_id] ) if params[:grupo_id]
    @objeto_nombre = case params[:objeto]
                       when "libro" then "Cuenta"
                       else  params[:objeto].titleize
                     end
    render :partial => "grupo_usuario/asignar_grupo", :locals => {:objeto => params[:objeto], :update => params[:update]}
  end

  def crear_modificar_asignacion
    @message = nil
    @objeto = eval( params[:objeto].split('_').map(&:capitalize).join ).find( params[:id].to_s )
    if params[:grupo_id]
      eval( "@grupo_relacionado = GrupoUsuarioX" + params[:objeto].split('_').map(&:capitalize).join + ".find( :first, :conditions => {:grupo_usuario_id => params[:grupo_id], :" + params[:objeto] + "_id =>  params[:id]} )" )
      if params[:grupo] && params[:grupo][:rol]
        #params[:usuario][:notificar] = (params[:grupo][:rol] != "auditor" && params[:usuario][:rol] != "configurador")
        @grupo_relacionado.update_attributes params[:grupo]
      end
    # Cuando no hay params[:grupo_id]? -> Cuando se crea nuevo
    else
      @grupo_relacionado =  eval( "GrupoUsuarioX" + params[:objeto].split('_').map(&:capitalize).join + ".create(:grupo_usuario_id => params[:grupo][:grupo_usuario_id], :" + params[:objeto] + "_id =>  params[:id], :rol =>  params[:grupo][:rol])" ) if params[:grupo]
      params[:grupo_id] = params[:grupo][:grupo_usuario_id]
    end
    @grupos_x = eval( "@objeto.grupo_usuario_x_" + params[:objeto] )

    if @grupo_relacionado.errors.empty?
      grupo_asignado = GrupoUsuario.find_by_id( params[:grupo_id] )
      # Si queremos propagar permisos (en proyectos o agentes), lo hacemos
      if params[:selector] && params[:selector][:forzar_permisos] && params[:selector][:forzar_permisos] == "1"
        # Asigna los implementadores
        @objeto.implementador.each do |implementador|
          GrupoUsuarioXAgente.find_or_create_by_grupo_usuario_id_and_agente_id(grupo_asignado.id,implementador.id)
        end if grupo_asignado && @objeto.class.name == "Proyecto"
        # Asigna los libros
        @objeto.libro.each do |libro|
          GrupoUsuarioXLibro.find_or_create_by_grupo_usuario_id_and_libro_id(grupo_asignado.id,libro.id)
        end if grupo_asignado
      end
      # Envia correo de advertencia
      #for usuario in @objeto.usuario
      #  begin
      #    Correo.asignar_usuario(request.host_with_port, usuario, usuario_asignado, params[:usuario] ? params[:usuario][:rol] : nil, @objeto).deliver
      #  rescue
      #    @message = _("No se ha podido mandar el mail a algún usuario")
      #  end
      #end
    end
    render :update do |page|
      page.replace params[:update] + "_grupos", :partial => "grupo_usuario/grupos"
      page.replace 'formulario', :inline => '<%= mensaje_error(@grupo_relacionado ? (@message || @grupo_relacionado) : "Se han producido errores. No se guardan los datos.") %><br>'
    end
  end

  def desasignar_grupo
    @objeto = eval( params[:objeto].split('_').map(&:capitalize).join ).find( params[:id].to_s )
    eval( "GrupoUsuarioX" + params[:objeto].split('_').map(&:capitalize).join + ".find( params[:grupo_usuario_x_objeto_id] ).destroy" )
    @grupos_x = eval( "@objeto.grupo_usuario_x_" + params[:objeto] )
    render :update do |page|
      page.replace params[:update] + "_grupos", :partial => "grupo_usuario/grupos"
      page.replace_html 'MB_content', :inline => '<%= mensaje_error(@objeto, :eliminar => true) %><br>'
      page.call("Modalbox.resizeToContent")
    end
  end

end
