# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2015 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class Tarea < ActiveRecord::Base
  #untranslate_all
  validates_presence_of :titulo, :message => _("Titulo") + " " + _("no puede estar vacío.")

  has_many :comentario, as: :elemento, dependent: :destroy
  belongs_to :proyecto
  #belongs_to :financiacion
  belongs_to :agente
  belongs_to :usuario
  belongs_to :tipo_tarea
  belongs_to :estado_tarea
  belongs_to :usuario_asignado, :foreign_key => "usuario_asignado_id", :class_name => "Usuario"

  def fecha_creacion
    self.created_at
  end

  def ultima_modificacion
    self.updated_at
  end

  def asignado_a
    self.usuario_asignado.nombre if self.usuario_asignado
  end

  def creado_por
    self.usuario.nombre if self.usuario
  end

  def estado_actual
    self.estado_tarea.nombre if self.estado_tarea
  end

  def nombre_objeto_relacionado
    (self.proyecto || self.agente).nombre
  end

  def estado_color
    if self.estado_tarea && !self.estado_tarea.activo
      "verde"
    elsif self.fecha_inicio and Date.today >= self.fecha_inicio
      if self.fecha_fin.nil?
        "rojo"
      else 
        if Date.today <= self.fecha_fin
          "rosa" 
        else
          "rojo"
        end
      end
    end 
  end

end
